-- CONSTANTS *************************************************************************************

Mission = {}
Mission.playerGroups = {}
Mission.radioMenusAdded = {}

Mission.RedWatchTowerAlive = false
Mission.BlueWatchTowerAlive = false

Mission.redAirDispatcherStarted = false

_SETTINGS:SetEraCold()
_SETTINGS:SetA2A_BRAA()

-- AWACS & TANKER ***
blueAwacs = SPAWN
	:New( "BLUE AWACS" )
	:InitLimit(1,0)
	:OnSpawnGroup(
		function(MooseGroup)
            Mission.spawnAwacsEscort(MooseGroup)
			MooseGroup:HandleEvent(EVENTS.Land)
			function MooseGroup:OnEventLand(EventData)
		        MooseGroup:Destroy()
		    end
		end
	)
	:SpawnScheduled(900, 1)

blueTanker = SPAWN
	:New( "BLUE TANKER" )
	:InitLimit(1,0)
	:OnSpawnGroup(
		function(MooseGroup)
            Mission.spawnTankerEscort(MooseGroup)
			MooseGroup:HandleEvent(EVENTS.Land)
			function MooseGroup:OnEventLand(EventData)
		        MooseGroup:Destroy()
		    end
		end
	)
	:SpawnScheduled(900, 1)

function Mission.spawnAwacsEscort(groupToEscort)
    local awacsEscort = SPAWN
        :New( "BLUE AWACS ESCORT" )
        :InitSkill("Veteran")
        :OnSpawnGroup( 
            function (MooseGroup)
                local escortPosition = POINT_VEC3:New( 1000, -1000, -1000  )
                local escortTask = MooseGroup:TaskEscort(groupToEscort, escortPosition, 5, 60000)
                MooseGroup:SetTask( escortTask, 1 ) 
            end
        )
        :Spawn()
end

function Mission.spawnTankerEscort(groupToEscort)
    local tankerEscort = SPAWN
        :New( "BLUE TANKER ESCORT" )
        :InitSkill("Veteran")
        :OnSpawnGroup( 
            function (MooseGroup)
                local escortPosition = POINT_VEC3:New( 1000, -1000, -1000  )
                local escortTask = MooseGroup:TaskEscort(groupToEscort, escortPosition, 5, 60000)
                MooseGroup:SetTask( escortTask, 1 ) 
            end
        )
        :Spawn()
end

-- BLUE RESCUE HELO ***
blueRescueHeloCVN=RESCUEHELO:New(UNIT:FindByName("BLUE CVN-71"), "BLUE RESCUE HELO")
blueRescueHeloCVN:SetTakeoffAir()
blueRescueHeloCVN:Start()

env.info("Rescue Helo loaded...")
trigger.action.outText("Rescue Helo loaded ...", 10)

-- RED IADS ***
redIADS = SkynetIADS:create('Pravda')
redIADS:addSAMSitesByPrefix('RED SAM')
redIADS:addEarlyWarningRadar('RED EWR KUWEIRES')
redIADS:addEarlyWarningRadar('RED EWR 312TH')
-- set powerplants
mainPowerplant = StaticObject.getByName("MAIN POWERPLANT")  
secondaryPowerPlant = StaticObject.getByName("SECONDARY POWERPLANT")
backupPowerPlant = StaticObject.getByName("BACKUP POWERPLANT") 
mainConnectionComm = StaticObject.getByName("MAIN COMMS") 
secondaryConnectionComm = StaticObject.getByName("SECONDARY COMMS") 

-- add command centers and power them
commandCenterIADS = StaticObject.getByName("RED IADS HQ")
redIADS:addCommandCenter(commandCenterIADS)
	:addPowerSource(mainPowerplant)
	:addPowerSource(secondaryPowerPlant)
	:addConnectionNode(mainConnectionComm)
commandCenterFrontline = StaticObject.getByName("RED FRONTLINE HQ")
redIADS:addCommandCenter(commandCenterIADS)
	:addPowerSource(backupPowerPlant)
	:addConnectionNode(secondaryConnectionComm)
-- connect power to EW
redIADS:getEarlyWarningRadarByUnitName('RED EWR KUWEIRES')
	:addPowerSource(mainPowerplant)
	:addPowerSource(secondaryPowerPlant)
	:addConnectionNode(mainConnectionComm)
redIADS:getEarlyWarningRadarByUnitName('RED EWR 312TH')
	:addPowerSource(mainPowerplant)
	:addPowerSource(backupPowerPlant)
	:addConnectionNode(secondaryConnectionComm)
-- setup sam sites
redIADS
	:getSAMSiteByGroupName('RED SAM ALEPPO SA-6')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(75)
redIADS
	:getSAMSiteByGroupName('RED SAM JIRAH SA2')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
:setGoLiveRangeInPercent(85)
redIADS
	:getSAMSiteByGroupName('RED SAM KABIR SA2')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
:setGoLiveRangeInPercent(85)
redIADS
	:getSAMSiteByGroupName('RED SAM JIRAH SA6')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(100)
redIADS
	:getSAMSiteByGroupName('RED SAM DAMASCUS SA2-1')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(75)
redIADS
	:getSAMSiteByGroupName('RED SAM DAMASCUS SA2-4')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(90)
redIADS
	:getSAMSiteByGroupName('RED SAM DAMASCUS SA6-1')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(90)
redIADS
	:getSAMSiteByGroupName('RED SAM DAMASCUS SA6-2')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(90)
redIADS
	:getSAMSiteByGroupName('RED SAM DAMASCUS SA6-3')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(75)
redIADS
	:getSAMSiteByGroupName('RED SAM DAMASCUS SA8')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(100)
redIADS
	:getSAMSiteByGroupName('RED SAM HOMS SA8')
	:addConnectionNode(mainConnectionComm)
	:addConnectionNode(secondaryConnectionComm)
	:setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DCS_AI)
	:setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)
	:setGoLiveRangeInPercent(100)
-- turn the thing on
redIADS:activate()

-- HQ CENTERS ***
blueHQ = GROUP:FindByName( "BLUE HQ", "Zeus HQ" )
blueCC = COMMANDCENTER:New( blueHQ, "Zeus" )

redHQ = GROUP:FindByName( "RED HQ", "Syria HQ")
redCC = COMMANDCENTER:New( redHQ, "Syria" )

-- BLUE CAP
BLUE_A2A_UNITS = {"BLUE CAP F5", "BLUE CAP F4"}
BlueA2ADetectionSetGroup = SET_GROUP:New()
BlueA2ADetectionSetGroup:FilterPrefixes( {"BLUE CVG", "BLUE AWACS"} )
BlueA2ADetectionSetGroup:FilterStart()
BlueA2ADetection = DETECTION_AREAS:New( BlueA2ADetectionSetGroup, 5000 )

blueAirDispatcher = AI_A2A_DISPATCHER:New( BlueA2ADetection )
blueAirDispatcher:SetEngageRadius( 100000 )
blueAirspace = ZONE_POLYGON:NewFromGroupName( "BLUE AIRSPACE" )
blueAirDispatcher:SetCommandCenter( blueCC )
blueAirDispatcher:SetTacticalDisplay( false )
blueAirDispatcher:SetBorderZone( blueAirspace )

blueAirDispatcher:SetSquadron( "Incirlik", AIRBASE.Syria.Incirlik, BLUE_A2A_UNITS, 8 )
blueAirDispatcher:SetSquadronCap( "Incirlik", blueAirspace, 5000, 8000, 800, 950, 1000, "BARO" )
blueAirDispatcher:SetSquadronTakeoffFromParkingHot("Incirlik")
blueAirDispatcher:SetSquadronLandingAtEngineShutdown( "Incirlik" )
blueAirDispatcher:SetSquadronGrouping( "Incirlik", 1 )
blueAirDispatcher:SetSquadronOverhead( "Incirlik", 1 )

blueAirDispatcher:SetSquadron( "USN", "BLUE CVN-71", {"BLUE CAP F-14"}, 8 )
blueAirDispatcher:SetSquadronCap( "USN", blueAirspace, 5000, 8000, 800, 950, 1000, "BARO" )
blueAirDispatcher:SetSquadronTakeoffFromParkingHot("USN")
blueAirDispatcher:SetSquadronLandingAtEngineShutdown( "USN" )
blueAirDispatcher:SetSquadronGrouping( "USN", 1 )
blueAirDispatcher:SetSquadronOverhead( "USN", 1 )
blueAirDispatcher:Start()

-- RED GCI
RED_A2A_UNITS = {"RED CAP 21 K13", "RED CAP 21 R60", "RED CAP 19", "RED CAP 23"}
redA2ADetectionSetGroup = SET_GROUP:New()
redA2ADetection = DETECTION_AREAS:New( redA2ADetectionSetGroup, 30000 )
redAirDispatcher = AI_A2A_DISPATCHER:New( redA2ADetection )
redAirDispatcher:SetEngageRadius( 100000 )
redAirDispatcher:SetGciRadius(150000)
redAirspace = ZONE_POLYGON:NewFromGroupName( "RED AIRSPACE" )
redAirDispatcher:SetCommandCenter( redCC )
redAirDispatcher:SetTacticalDisplay( false )
redAirDispatcher:SetBorderZone( redAirspace )

redAirDispatcher:SetSquadron( "Kuweires", AIRBASE.Syria.Kuweires, RED_A2A_UNITS, 4 )
redAirDispatcher:SetSquadronTakeoffFromParkingHot("Kuweires")
redAirDispatcher:SetSquadronLandingAtEngineShutdown( "Kuweires" )
redAirDispatcher:SetSquadronGci( "Kuweires", 900, 1200 )
redAirDispatcher:SetSquadronGrouping( "Kuweires", 1 )
redAirDispatcher:SetSquadronOverhead( "Kuweires", 1 )

-- we start dispatcher only in relevant missions
-- redAirDispatcher:Start()
-- Add Moose GCI to Skynet IADS
redIADS:addMooseSetGroup(redA2ADetectionSetGroup)

-- Start/Stop Red Air Dispatcher
function Mission.startRedAirDispatcherIfStopped()
	if Mission.redAirDispatcherStarted == false then
		redAirDispatcher:Start()
		Mission.redAirDispatcherStarted = true
		env.info("Starting Red Air Dispatcher...")
	end
end

function Mission.stopRedAirDispatcherIfStarted()
	if Mission.redAirDispatcherStarted == true then
		redAirDispatcher:Stop()
		Mission.redAirDispatcherStarted = false
		env.info("Stopping Red Air Dispatcher...")
	end
end

-- Blue Missiong Milk Run ***
function Mission.blueMissionMilkRun(groupId)
	Mission.stopRedAirDispatcherIfStarted()
	local redAAAJisr = SPAWN
		:New( "RED AAA JISR" )
		:InitSkill("Average")
		:Spawn()

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Milk Run mission started, see map ...", 10)
end

-- Blue Mission BARCAP ***
function Mission.blueMissionBarcap(groupId)
	Mission.stopRedAirDispatcherIfStarted()
	local redCapOne = SPAWN
		:New( "RED MISSION BARCAP#2" )
		:InitRandomizeTemplate(RED_A2A_UNITS)
		:InitSkill("Random")
        :OnSpawnGroup(
			function(MooseGroup)
				MooseGroup:HandleEvent(EVENTS.Dead)
				function MooseGroup:OnEventDead(EventData)
					Mission.startRedAirDispatcherIfStopped()
				end
			end)

	local redCapTwo = SPAWN
		:New( "RED MISSION BARCAP#1" )
		:InitRandomizeTemplate(RED_A2A_UNITS)
		:InitSkill("Random")
		:OnSpawnGroup(
			function(MooseGroup)
				MooseGroup:HandleEvent(EVENTS.Dead)
				function MooseGroup:OnEventDead(EventData)
					redCapOne:Spawn()
				end
			end)
		:Spawn()

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "BARCAP mission started, see map ...", 10)
end

-- Bue Mission Deck Alert ***
function Mission.blueMissionDeckAlert(groupId)
	Mission.stopRedAirDispatcherIfStarted()
	local redPatrolBoat = SPAWN
		:New( "RED PATROL BOAT" )
		:InitSkill("Random")
		:OnSpawnGroup(
			function(MooseGroup)
				MooseGroup:HandleEvent(EVENTS.Dead)
				function MooseGroup:OnEventDead(EventData)
					capJirah:Spawn()
				end
			end)
		:Spawn()

	local redPatrolBoatTasks = {}
	local blueCVGroup = GROUP:FindByName( "BLUE CVG" )
	local blueCVUnits = blueCVGroup:GetUnits()
	-- arty units in mission editor must have 3 units
	for i = 1, #blueCVUnits do
		local blueCVUnitToAttack = blueCVGroup:GetUnit( i )
		redPatrolBoatTasks[#redPatrolBoatTasks+1] = redPatrolBoat:TaskAttackUnit( blueCVUnitToAttack )
	end

	redPatrolBoat:PushTask( redPatrolBoat:TaskCombo( redPatrolBoatTasks ), 30 )

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Deck Alert mission started, see map ...", 10)
end

-- Bue Mission Hornet's Nest ***
function Mission.blueMissionHornetsNest(groupId, spawnEscorts)
	Mission.startRedAirDispatcherIfStopped()
	hornetNestBuffOne = SPAWN
		:New( "BLUE HORNETS NEST#1" )
		:InitSkill("Veteran")
		:Spawn()
	hornetNestBuffTwo = SPAWN
		:New( "BLUE HORNETS NEST#2" )
		:InitSkill("Veteran")
		:Spawn()

	if (spawnEscorts) then
		local hornetNestEscort = SPAWN
			:New( "BLUE HORNETS NEST ESCORT" )
			:InitSkill("Veteran")
			:OnSpawnGroup( 
				function (MooseGroup)
					local escortPosition = POINT_VEC3:New( 1000, -1000, -1000  )
					local escortTask = MooseGroup:TaskEscort(hornetNestBuffOne, escortPosition, 5, 80000, {"Air"})
					MooseGroup:SetTask( escortTask, 1 ) 
				end
			)
			:Spawn()
	end

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Hornet's Nest started, rendezvous in 15 minutes, see map ...", 10)
end

-- Blue Mission Tally Ho Yo ***
function Mission.blueMissionTallyHoYo(groupId, isPlayerStrike, isPlayerIronHand)
	Mission.stopRedAirDispatcherIfStarted()
	local aaaKramelBridge = SPAWN
		:New( "RED AAA KRAMEEL" )
		:InitSkill("Average")
		:OnSpawnGroup(
			function(MooseGroup)
				MooseGroup:HandleEvent(EVENTS.Dead)
				function MooseGroup:OnEventDead(EventData)
					capJirah:Spawn()
				end
			end)
		:Spawn()

	if isPlayerStrike == true then
		local tallyHoYoIronHandOne = SPAWN
			:New( "BLUE TALLYHOYO IRONHAND#1" )
			:InitSkill("Veteran")
			:Spawn()
		local tallyHoYoIronHandTwo = SPAWN
			:New( "BLUE TALLYHOYO IRONHAND#2" )
			:InitSkill("Veteran")
			:Spawn()
	end

	if isPlayerIronHand == true then
		local tallyHoYoStrike = SPAWN
			:New( "BLUE TALLYHOYO STRIKE" )
			:InitSkill("Veteran")
			:Spawn()
	end

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Tally Ho Yo mission started, see map ...", 10)
end

-- Blue Mission Back Breaker ***
function Mission.blueMissionBackBreaker(groupId, isPlayerStrike, isPlayerIronHand, isPlayerMigcap)
	Mission.startRedAirDispatcherIfStopped()
	local redMinakhAAA = SPAWN
		:New("RED AAA MINAKH")
		:InitSkill("Good")
		:Spawn()
	local redMinakhTroopsOne = SPAWN
		:New("RED TROOPS MINAKH")
		:InitSkill("Good")
		:Spawn()
	local redMinakhTroopsTwo = SPAWN
		:New("RED TROOPS MINAKH-1")
		:InitSkill("Good")
		:Spawn()

	if isPlayerStrike == false then
		local backBreakerStrikeOne = SPAWN
			:New("BLUE BACKBREAKER STRIKE#1")
			:InitSkill("Veteran")
			:Spawn()
		local backBreakerStrikeTwo = SPAWN
			:New("BLUE BACKBREAKER STRIKE#2")
			:InitSkill("Veteran")
			:Spawn()
	end

	if isPlayerIronHand == false then
		local backBreakerIronHandOne = SPAWN
			:New("BLUE BACKBREAKER IRONHAND#1")
			:InitSkill("Veteran")
			:Spawn()
		local backBreakerIronHandTwo = SPAWN
			:New("BLUE BACKBREAKER IRONHAND#2")
			:InitSkill("Veteran")
			:Spawn()
	end

	if isPlayerMigcap == false then
		local backBreakerMigcapOne = SPAWN
			:New("BLUE BACKBREAKER MIGCAP#1")
			:InitSkill("Veteran")
			:Spawn()
		local backBreakerMigcapTwo = SPAWN
			:New("BLUE BACKBREAKER MIGCAP#2")
			:InitSkill("Veteran")
			:Spawn()
	end

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Back Breaker mission started, see map ...", 10)
end

-- Blue Mission Special Delivery ***
function Mission.blueMissionSpecialDelivery(groupId, isPlayerStrikesShips, isPlayerStrikeHarbour, isPlayerIronHand)
    local specialDeliveryShipOne = SPAWN
			:New("RED CARGO SHIP-10")
			:InitSkill("Veteran")
			:Spawn()
        local specialDeliveryShipFour = SPAWN
			:New("RED CARGO SHIP-4")
			:InitSkill("Veteran")
			:Spawn()
        local specialDeliveryShipFive = SPAWN
			:New("RED CARGO SHIP-5")
			:InitSkill("Veteran")
			:Spawn()
        local specialDeliveryShipEight = SPAWN
			:New("RED CARGO SHIP-8")
			:InitSkill("Veteran")
			:Spawn()
    if isPlayerIronHand == false then
        local specialDeliveryIronHand = SPAWN
			:New("BLUE SPECIALDELIVERY IRONHAND")
			:InitSkill("Veteran")
			:Spawn()
    end
    if isPlayerStrikesShips == false then
        local specialDeliveryStrikeOne = SPAWN
            :New("BLUE SPECIALDELIVERY STRIKE-1")
            :InitSkill("Veteran")
            :Spawn()
        local specialDeliveryStrikeTwo = SPAWN
            :New("BLUE SPECIALDELIVERY STRIKE-2")
            :InitSkill("Veteran")
            :Spawn()
    end
	if isPlayerStrikeHarbour == false then
		local specialDeliveryStrikeThree = SPAWN
            :New("BLUE SPECIALDELIVERY STRIKE-3")
            :InitSkill("Veteran")
            :Spawn()
	end

    trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Special Delivery mission started, see map ...", 10)
end

-- Blue Mission Desert Meteor ***
function Mission.blueMissionDesertMeteor(groupId, isPlayerStrike, isPlayerIronHand, isPlayerMigcap)
	Mission.startRedAirDispatcherIfStopped()

	local redJisrBridgeAAAOne = SPAWN
		:New( "RED JISR BRIDGE AAA#1" )
		:InitSkill("Average")
		:Spawn()
	local redJisrBridgeAAATwo = SPAWN
		:New( "RED JISR BRIDGE AAA#2" )
		:InitSkill("Average")
		:Spawn()

	if isPlayerStrike == false then
		desertMeteorStrikeOne = SPAWN
            :New("BLUE DESERT METEOR STRIKE #1")
            :InitSkill("Veteran")
            :Spawn()
		desertMeteorStrikeTwo = SPAWN
            :New("BLUE DESERT METEOR STRIKE #2")
            :InitSkill("Veteran")
            :Spawn()
	end

	if isPlayerIronHand == false then
		local desertMeteorIronHand = SPAWN
            :New("BLUE DESERT METEOR IRON HAND")
            :InitSkill("Veteran")
            :Spawn()
		local desertMeteorIronHandTasks = {}
		local unitToAttackOne = redJisrBridgeAAAOne:GetUnit( 1 )
		local unitToAttackTwo = redJisrBridgeAAATwo:GetUnit( 1 )
		desertMeteorIronHandTasks[#desertMeteorIronHandTasks+1] = desertMeteorIronHand:TaskAttackUnit( unitToAttackOne )
		desertMeteorIronHandTasks[#desertMeteorIronHandTasks+1] = desertMeteorIronHand:TaskAttackUnit( unitToAttackTwo )		
		desertMeteorIronHand:PushTask( desertMeteorIronHand:TaskCombo( desertMeteorIronHandTasks ), 30 )
	end

	if isPlayerMigcap == false then
		local desertMeteorMigcap = SPAWN
            :New("BLUE DESERT METEOR MIGCAP")
            :InitSkill("Veteran")
			:OnSpawnGroup( 
				function (MooseGroup)
					local escortPosition = POINT_VEC3:New( 1000, -1000, 3000  )
					local escortTask = MooseGroup:TaskEscort(desertMeteorStrikeOne, escortPosition, 5, 5000, {"Air"})
					MooseGroup:SetTask( escortTask, 1 ) 
				end
        	)
            :Spawn()
	end

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Desert Meteor mission started, see map ...", 10)
end

-- Blue Heli Mission Rat's Den ***
function Mission.blueMissionRatsDen(groupId)
	Mission.stopRedAirDispatcherIfStarted()
	local ratsNestQusayrTroops = SPAWN
		:New( "RED TROOPS QUSAYR" )
		:InitSkill("Average")
		:Spawn()
	local ratsNestQusayrArtyOne = SPAWN
		:New( "RED ARTY QUSAYR-1" )
		:InitSkill("Average")
		:Spawn()
	local ratsNestQusayrArtyTwo = SPAWN
		:New( "RED ARTY QUSAYR-2" )
		:InitSkill("Average")
		:Spawn()
	local ratsNestQusayrArtyThree = SPAWN
		:New( "RED ARTY QUSAYR-3" )
		:InitSkill("Average")
		:Spawn()
	local ratsNestSpadOne = SPAWN
		:New( "BLUE SPAD#1" )
		:InitSkill("Veteran")
		:Spawn()
	local ratsNestSpadTwo = SPAWN
		:New( "BLUE SPAD#2" )
		:InitSkill("Veteran")
		:Spawn()

	local spadOneTasks = {}
	local spadTwoTasks = {}
	-- arty units in mission editor must have 3 units
	for i = 1, 3 do
		local unitToAttackOne = ratsNestQusayrArtyOne:GetUnit( i )
		local unitToAttackTwo = ratsNestQusayrArtyTwo:GetUnit( i )
		local unitToAttackThree = ratsNestQusayrArtyThree:GetUnit( i )
		spadOneTasks[#spadOneTasks+1] = ratsNestSpadOne:TaskAttackUnit( unitToAttackOne )
		spadOneTasks[#spadOneTasks+1] = ratsNestSpadOne:TaskAttackUnit( unitToAttackTwo )
		spadTwoTasks[#spadTwoTasks+1] = ratsNestSpadTwo:TaskAttackUnit( unitToAttackThree )
		spadTwoTasks[#spadTwoTasks+1] = ratsNestSpadTwo:TaskAttackUnit( unitToAttackTwo )
	end

	ratsNestSpadOne:PushTask( ratsNestSpadOne:TaskCombo( spadOneTasks ), 30 )
	ratsNestSpadTwo:PushTask( ratsNestSpadTwo:TaskCombo( spadTwoTasks ), 30 )

	-- TODO add code to spawn blue gi to conquer airbase
	local ratsNestTroopsBlueOne = SPAWN
		:New( "BLUE TROOPS QUSAIR#1" )
		:InitSkill("Veteran")
		:Spawn()
	
	local ratsNestTroopsBlueTwo = SPAWN
		:New( "BLUE TROOPS QUSAIR#2" )
		:InitSkill("Veteran")
		:Spawn()

	local ratsNestTroopsBlueThree = SPAWN
		:New( "BLUE TROOPS QUSAIR#3" )
		:InitSkill("Veteran")
		:Spawn()

	trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	trigger.action.outTextForGroup(groupId, "Rat's Den mission started, see map ...", 10)
end

-- Red Mission Homeland Defense
function Mission.redMissionHomelandDefense(groupId)
	Mission.stopRedAirDispatcherIfStarted()
	redRandomMission = math.random(0, 100 )
	if (redRandomMission >= 80) then
		Mission.blueMissionHornetsNest(0, true)
	end
	if (redRandomMission >= 60 and redRandomMission < 80) then
		Mission.blueMissionTallyHoYo(groupId, false, false)
	end
	if (redRandomMission >= 40 and redRandomMission < 60) then
		Mission.blueMissionBackBreaker(groupId, false, false, false)
	end
	if (redRandomMission >= 20 and redRandomMission < 40) then
		Mission.blueMissionSpecialDelivery(groupId, false, false, false)
	end
	if (redRandomMission < 20) then
		Mission.blueMissionDesertMeteor(groupId, false, false, false)
	end
end

-- ADD RADIO MENUS ***
function Mission.addBlueRadioMenus()
	local playerGroups = SET_GROUP:New():FilterPrefixes("PLAYER BLUE"):FilterActive(true):FilterStart()
	playerGroups:ForEach(
		function(playerGroup)
			local groupId = playerGroup:GetID()
			if Mission.radioMenusAdded[tostring(groupId)] == nil then
				Mission.radioMenusAdded[tostring(groupId)] = true
				local missionsMenu = missionCommands.addSubMenuForGroup(groupId, "Missions")
				-- single menu missions ***
				missionCommands.addCommandForGroup(groupId, "(AIR) Milk Run", missionsMenu,  Mission.blueMissionMilkRun, groupId)
				missionCommands.addCommandForGroup(groupId, "(AIR) BARCAP", missionsMenu,  Mission.blueMissionBarcap, groupId)
				missionCommands.addCommandForGroup(groupId, "(AIR) Deck Alert", missionsMenu,  Mission.blueMissionDeckAlert, groupId, true)
				missionCommands.addCommandForGroup(groupId, "(AIR) Hornet's Nest", missionsMenu,  Mission.blueMissionHornetsNest, groupId, false)

				-- multiple level missions ***
				local missionTallyHoYoMenu = missionCommands.addSubMenuForGroup(groupId, "(AIR) Tally Ho Yo!", missionsMenu)
				missionCommands.addCommandForGroup(groupId, "Strike", missionTallyHoYoMenu,  Mission.blueMissionTallyHoYo, groupId, true, false)
				missionCommands.addCommandForGroup(groupId, "Iron Hand", missionTallyHoYoMenu,  Mission.blueMissionTallyHoYo, groupId, false, true)
				missionCommands.addCommandForGroup(groupId, "Free Role", missionTallyHoYoMenu,  Mission.blueMissionTallyHoYo, groupId, false, false)
				
				local missionBackBreaker = missionCommands.addSubMenuForGroup(groupId, "(AIR) Back Breaker", missionsMenu)
				missionCommands.addCommandForGroup(groupId, "Strike", missionBackBreaker, Mission.blueMissionBackBreaker, groupId, true, false, false)
				missionCommands.addCommandForGroup(groupId, "Iron Hand", missionBackBreaker, Mission.blueMissionBackBreaker, groupId, false, true, false)
				missionCommands.addCommandForGroup(groupId, "MiGCAP", missionBackBreaker, Mission.blueMissionBackBreaker, groupId, false, false, true)
				missionCommands.addCommandForGroup(groupId, "Free Role", missionBackBreaker, Mission.blueMissionBackBreaker, groupId, false, false, false)

                local missionSpecialDelivery = missionCommands.addSubMenuForGroup(groupId, "(AIR) Special Delivery", missionsMenu)
                missionCommands.addCommandForGroup(groupId, "Strike Docks", missionSpecialDelivery, Mission.blueMissionSpecialDelivery, groupId, false, true, false)
                missionCommands.addCommandForGroup(groupId, "Strike Ships", missionSpecialDelivery, Mission.blueMissionSpecialDelivery, groupId, true, false, false)
				missionCommands.addCommandForGroup(groupId, "Iron Hand", missionSpecialDelivery, Mission.blueMissionSpecialDelivery, groupId, false, false, true)
				missionCommands.addCommandForGroup(groupId, "Free Role", missionSpecialDelivery, Mission.blueMissionSpecialDelivery, groupId, false, false, false)

				local missionDesertMeteor = missionCommands.addSubMenuForGroup(groupId, "(AIR) Desert Meteor", missionsMenu)
                missionCommands.addCommandForGroup(groupId, "Strike", missionDesertMeteor, Mission.blueMissionDesertMeteor, groupId, true, false, false)
				missionCommands.addCommandForGroup(groupId, "Iron Hand", missionDesertMeteor, Mission.blueMissionDesertMeteor, groupId, false, true, false)
				missionCommands.addCommandForGroup(groupId, "MiGCAP", missionDesertMeteor, Mission.blueMissionDesertMeteor, groupId, false, false, true)
				missionCommands.addCommandForGroup(groupId, "Free Role", missionDesertMeteor, Mission.blueMissionDesertMeteor, groupId, false, false, false)

				-- heli missions
				missionCommands.addCommandForGroup(groupId, "(HELI) Rat's Den", missionsMenu,  Mission.blueMissionRatsDen, groupId)

				missionCommands.addCommandForGroup(groupId, "AIR Radio frequencies", nil,  Mission.listBlueAirRadioFrequencies, groupId)
				missionCommands.addCommandForGroup(groupId, "HELI Radio frequencies", nil,  Mission.listBlueHeliRadioFrequencies, groupId)
			end
		end
	)
end

function Mission.addRedRadioMenus()
	local playerGroups = SET_GROUP:New():FilterPrefixes("PLAYER RED"):FilterActive(true):FilterStart()
	playerGroups:ForEach(
		function(playerGroup)
			local groupId = playerGroup:GetID()
			if Mission.radioMenusAdded[tostring(groupId)] == nil then
				Mission.radioMenusAdded[tostring(groupId)] = true
				missionCommands.addCommandForGroup(groupId, "Homeland Defense", nil,  Mission.redMissionHomelandDefense, groupId)
				missionCommands.addCommandForGroup(groupId, "Air Dispatcher DISABLE", nil,  Mission.stopRedAirDispatcherIfStarted, groupId)
				missionCommands.addCommandForGroup(groupId, "Air Dispatcher ENABLE", nil,  Mission.startRedAirDispatcherIfStopped, groupId)
				missionCommands.addCommandForGroup(groupId, "List Radio frequencies", nil,  Mission.listRedRadioFrequencies, groupId)
			end
		end
	)
end

-- reschedule for users that change slot or coalition
RADIO_MENU_SCHEDULER = SCHEDULER:New(nil,
  function()
    -- ADD MENUS FOR RED
    Mission.addBlueRadioMenus()
    -- ADD MENUS FOR BLUE
    Mission.addRedRadioMenus()
  end, {}, 0, 30, 0 )

-- LIST RADIO FREQUENCIES FUNCTIONS ***

function Mission.listBlueAirRadioFrequencies(_groupId)
	trigger.action.outTextForGroup(_groupId, 
[[
Radio  presets COM1/COM2:
#1 230 MHz (Air units / Wizard AWACS)
#2 252 MHz (Buff)
#3 360.1 MHz (Incirlik ATC)
#4 Tanker Shell 269 MHz / TCN 69X

*** F-14
ARC-159
#1 230 MHz (Air units / Wizard AWACS)
#2 252 MHz (Buff)
#3 269 MHz (Shell Tanker)
#4 227 MHz (CVN-71)

ARC-182
#1 230 MHz (Air units / Wizard AWACS)
#2 252 MHz (Buff)
#3 227 MHz (CVN-71)
#4 118.6 (Ramat David ATC)
#5 122.1 (Incirlik ATC)

Incirlik TCN 21X
CVN-71 TCN 71X
Shell TCN 20X
]]
		, 15 , false)  
	trigger.action.outSoundForGroup(_groupId, "walkietalkie.ogg")
end

function Mission.listBlueHeliRadioFrequencies(_groupId)
	trigger.action.outTextForGroup(_groupId, 
[[
Radio  presets COM1/COM2:
#1 225 MHz (Air units)

Dallas FARP 134.00 MHz - 450kHz NDB
]]
		, 15 , false)  
	trigger.action.outSoundForGroup(_groupId, "walkietalkie.ogg")
end

function Mission.listRedRadioFrequencies(_groupId)
	trigger.action.outTextForGroup(_groupId, 
[[
Radio  presets:
#0 130 MHz (Air units / 100 GCI)
#1 131 MHz (312th 200 GCI)
#2 120.5 MHz (Kuweires ATC)
]]
		, 15 , false)  
	trigger.action.outSoundForGroup(_groupId, "walkietalkie.ogg")
end

env.info("Radio Frequencies loaded...")
trigger.action.outText("Radio Frequencies loaded ...", 10)

-- SCORING ***

MissionScore = SCORING:New( "Baath Gamble" )
MissionScore:SetScaleDestroyScore( 100 )
MissionScore:SetScaleDestroyPenalty( 200 )
MissionScore:SetMessagesHit( false )
MissionScore:SetMessagesDestroy( false )
MissionScore:SetMessagesToAll( true )
MissionScore:AddZoneScore(ZONE:FindByName("MAIN POWERPLANT"), 50)
MissionScore:AddZoneScore(ZONE:FindByName("SECONDARY POWERPLANT"), 50)
MissionScore:AddZoneScore(ZONE:FindByName("BACKUP POWERPLANT"), 50)
MissionScore:AddZoneScore(ZONE:FindByName("MAIN COMMS"), 50)
MissionScore:AddZoneScore(ZONE:FindByName("SECONDARY COMMS"), 50)
MissionScore:AddZoneScore(ZONE:FindByName("RED HQ"), 100)
MissionScore:AddZoneScore(ZONE:FindByName("RED FRONTLINE HQ"), 100)

env.info("SCORING loaded ...")
trigger.action.outText("SCORING loaded ...", 10)

-- END ***

env.info("Mission loaded OK ...")
trigger.action.outText("Mission loaded OK ...", 10)

-- DEBUG ***
---debug settings remove from here on if you do not wan't any output on what the IADS is doing by default
-- redIADS:addRadioMenu()
-- local iadsDebug = redIADS:getDebugSettings()
-- iadsDebug.IADSStatus = true
-- iadsDebug.radarWentDark = true
-- iadsDebug.contacts = true
-- iadsDebug.radarWentLive = true
-- iadsDebug.noWorkingCommmandCenter = true
-- iadsDebug.samNoConnection = true
-- iadsDebug.jammerProbability = true
-- iadsDebug.addedEWRadar = true
-- iadsDebug.harmDefence = true
---end remove debug ---

--BASE:TraceOn()